User Interface API Developer Guide
Summer '26 (API version 67.0)
Spring '26 (API version 66.0)
Winter '26 (API version 65.0)
Summer '25 (API version 64.0)
Spring '25 (API version 63.0)
Winter '25 (API version 62.0)
Summer '24 (API version 61.0)
Spring '24 (API version 60.0)
Winter '24 (API version 59.0)
Summer '23 (API version 58.0)
Spring '23 (API version 57.0)
Winter '23 (API version 56.0)
Summer '22 (API version 55.0)
Spring '22 (API version 54.0)
Winter '22 (API version 53.0)
Summer '21 (API version 52.0)
Spring '21 (API version 51.0)
Winter '21 (API version 50.0)
Summer '20 (API version 49.0)
Spring '20 (API version 48.0)
Winter '20 (API version 47.0)
Summer '19 (API version 46.0)
Spring '19 (API version 45.0)
Winter '19 (API version 44.0)
Summer '18 (API version 43.0)
Spring '18 (API version 42.0)
Winter '18 (API version 41.0)
Summer '17 (API version 40.0)
Get Record Data and Object Metadata
Get Record Layout Metadata
Get a Directory of Supported Objects
Get Object Metadata
Get a Batch of Object Metadata
Get Values for a Picklist Field
Get Values for All Picklist Fields of a Record Type
Get Child Records
Get a Record
Get a Batch of Records
Create or Clone a Record
Create a Batch of Records
Get Default Values to Clone a Record
Get Default Values to Clone a Record—Lightweight
Get Default Values to Create a Record
Get Default Values to Create a Record—Lightweight
Update a Record
Update a Batch of Records
Delete a Record
Delete a Batch of Records
Get Lookup Field Suggestions With POST
Check for Duplicate Records
Get Duplicate Management Configuration for a Specified Object
Upload a File
Upload a New File Version
Get Active Theme
Newer Version Available
Records
Use these resources to get metadata and data about objects and
records. These resources make it easy to build Salesforce UI.
-
Get Record Data and Object Metadata
Get layout information, metadata, and data to build UI for a single record or for a collection of records. -
Get Record Layout Metadata
Get metadata about page layouts for the specified object type. -
Get a Directory of Supported Objects
Get a directory of objects that are supported by User Interface API and accessible to the context user. The directory includes a /ui-api/object-info/{objectApiName} resource for each supported object. -
Get Object Metadata
Get metadata about a specific object. The response includes metadata describing fields, child relationships, record type, and theme. -
Get a Batch of Object Metadata
Get metadata about specific objects. The response includes a batch of metadata describing fields, child relationships, record type, and theme. -
Get Values for a Picklist Field
If a field’s dataType property is equal to Picklist or MultiPicklist, use this resource to get its values. -
Get Values for All Picklist Fields of a Record Type
Use this resource to get the values for all the picklist fields of a specific record type. This resource is especially useful for getting dependent picklist values. For example, if an object has a tree of dependent picklists (Continents__c, Countries__c, Cities__c), use this resource to get all the values for each picklist in one request. -
Get Child Records
Get child records for a specified record and child relationship name. Relationships are connections between records. On a record detail page, each record in a related list has a child relationship to the parent record. -
Get a Record
Get a record’s data. -
Get a Batch of Records
Get data for a batch of records. -
Create or Clone a Record
Create or clone a record. -
Create a Batch of Records
Create multiple records. You can create, update, and delete up to 200 records in a single request. -
Get Default Values to Clone a Record
Get the default layout information, object information, and data for cloning a record. After getting the default values, make a request to POST /ui-api/records to create the record. -
Get Default Values to Clone a Record—Lightweight
Get the default values for fields for cloning a record. You must specify the fields you want returned. This resource doesn’t use or return layout information. After getting the default values, make a request to POST /ui-api/records to create the record. -
Get Default Values to Create a Record
Get the default values for fields for a new record of a specified object and optional record type. After getting the default values, make a request to POST /ui-api/records to create the record. -
Get Default Values to Create a Record—Lightweight
Get the default values for fields for a new record of a specified object and optional record type. You must specify the fields you want returned. This resource doesn’t use or return layout information. After getting the default values, make a request to POST /ui-api/records to create the record. -
Update a Record
Update a record's data. -
Update a Batch of Records
Update multiple records. You can create, update, and delete up to 200 records in a single request. -
Delete a Record
Delete a record. -
Delete a Batch of Records
Delete multiple records. You can create, update, and delete up to 200 records in a single request. -
Get Lookup Field Suggestions With POST
When a user edits a lookup field, use this resource to search for and display suggestions. You can search for most recently used matches, for matching names, or for any match in a searchable field. You must specify dependent lookup field values used by lookup filters in the `sourceRecord` request body parameter. -
Check for Duplicate Records
Before updating or creating a record, you can check whether a duplicate record exists. Use the response to learn whether to block or allow the action, and whether to warn the user. -
Get Duplicate Management Configuration for a Specified Object
Learn whether duplicate management is configured for the specified object. If duplicate management is configured, learn about the object's duplicate rules and matching rules. Use the information in the response to know when to check for duplicate records. -
Upload a File
Upload a file such as a document or image. -
Upload a New File Version
Upload a new document or image version.